//	SOKOBAN (C)2000 Sebastien Tiby

#define SAVE_SCREEN
#define USE_GRAY_PATCH

#include <nostub.h>
#include <all.h>

 int _ti89;

#define Couleur

#define kEsc	264
#define kF1 	268
#define kF2 	269
#define kF3 	270
#define kUp	337
#define kDown	340
#define kLeft	338
#define kRight	344

typedef char MAT[16][26];
 BOOL Sauve=FALSE;
 char* Nom= "\0\0         ";
 int Nlgn=0,Ncol=0,lgn=0,col=0;
 MAT jmat={}; MAT jmat2={};

unsigned char Imag[]=
{
 0x00,0x06,0x00,0x06,0x00,0x00,0x00,0x00,0x00,0x00,
 0x00,0x06,0x00,0x06,0x00,0x54,0x00,0x44,0x00,0x54,
 0x00,0x06,0x00,0x06,0x54,0xA8,0x54,0xA8,0x54,0xA8,
 0x00,0x06,0x00,0x06,0x00,0x78,0xFC,0xFC,0xFC,0x78,
 0x00,0x06,0x00,0x06,0x00,0x78,0x84,0x8C,0xBC,0x78,
 0x00,0x06,0x00,0x06,0x30,0x30,0xFC,0xFC,0x30,0x30,
#ifdef Couleur
 0x00,0x06,0x00,0x06,0xFC,0xFC,0xFC,0xFC,0xFC,0xFC,
 0x00,0x06,0x00,0x06,0xFC,0xFC,0xC4,0xC4,0xC4,0xFC,
 0x00,0x06,0x00,0x06,0xFC,0xFC,0xFC,0xFC,0xFC,0xFC,
 0x00,0x06,0x00,0x06,0xFC,0xFC,0x84,0x8C,0xBC,0xFC,
 0x00,0x06,0x00,0x06,0xFC,0xFC,0xCC,0x94,0x9C,0xFC,
 0x00,0x06,0x00,0x06,0xFC,0xFC,0xFC,0xFC,0xFC,0xFC
#endif
};
void AffImag(int l,int c,char Img)
{
#ifdef Couleur
 int i;
 for(i=0;i<=1;i++)
 {
  SetPlane(i);
  BitmapPut(6*(c+13-(Ncol>>1)),6*(l+8-(Nlgn>>1)),&Imag[10*(Img+6)-60*i],&(SCR_RECT){0,0,159,93},A_REPLACE);
 }
#else
 BitmapPut(6*(c+13-(Ncol>>1)),6*(l+8-(Nlgn>>1)),&Imag[10*Img],&(SCR_RECT){0,0,159,93},A_REPLACE);
#endif
}
int Ouvrir(void)
{
 char* menu[] = {"New","About","Exit"};
 SYM_ENTRY* SymPtr;
 unsigned char* VarPtr;
 int i=1,key=0,j;
 if(!Sauve)
 {
#ifdef Couleur
  for(j=0;j<=1;j++)
  {
   SetPlane(j);
#endif
   ClrScr();
   FontSetSys(F_6x8);
   DrawStr(1,1,"Level name:",A_REPLACE);
#ifdef Couleur
  }
#endif
  DrawStr(70,1,&Nom[1],A_REPLACE);
  while(Nom[i]!=0) i++;
  while(key!=13)
  {
   Nom[i]='_'; Nom[i+1]=' '; Nom[i+2]=0;
   DrawStr(70,1,&Nom[1],A_REPLACE);
   key=ngetchx();
   if(((key>='0'&&key<='9'&&i!=1)||(key>='A'&&key<='Z')||(key>='a'&&key<='z'))&&i<9) Nom[i++]=key;
    if(key==257&&(i-1)) i--;
   Nom[i]=0;
   if(key==kEsc) return FALSE;
  }
  if(i==1) return FALSE;

  SymPtr = SymFindPtr(Nom+i,0);
  if(!SymPtr) return FALSE;
  VarPtr = (unsigned char*)HeapDeref(SymPtr->handle);
  if(VarPtr[0]*256+VarPtr[1]<6) return FALSE;
  if(VarPtr[3]!=1 && VarPtr[4]!=2) return FALSE;
  Nlgn=VarPtr[5]+1; Ncol=VarPtr[6]+1;
  for(j=0;j<17;j+=16)
   for(i=0;i<Nlgn;i++)
    memcpy(&jmat[i+j][0],&VarPtr[7+i*Ncol],Ncol);
 }

 FontSetSys(F_4x6);
#ifdef Couleur
 for(i=0;i<2;i++)
 {
  SetPlane(i);
#endif
  ClrScr();
  for(j=0;j<96;j+=32)
  {
   SCR_RECT Rect = {j,93,j+30,99};
   DrawStr(j+15-DrawStrWidth(menu[j>>5],F_4x6)/2,94,menu[j>>5],A_NORMAL);
   ScrRectFill(&Rect,&(SCR_RECT){0,0,159,99},A_XOR);
   DrawStr(95,94,"Level:",A_NORMAL);
   DrawStr(117,94,&Nom[1],A_NORMAL);
  }
#ifdef Couleur
 }
#endif
 key=0;
 for(i=0;i<Nlgn;i++)
 {
  for(j=0;j<Ncol;j++)
  {
   if(!Sauve) jmat[i][j]=jmat2[i][j];
   AffImag(i,j,jmat[i][j]);
   if(jmat[i][j]==5)
   {
    lgn=i;
    col=j;
    key++;
   }
  }
 }
 return (key==1);
}

void deplace(signed int Dlgn,signed int Dcol)
{
 int i;
 if(lgn+Dlgn<Nlgn && col+Dcol<Ncol && col+Dcol>=0 && lgn+Dlgn>=0)
 {
  if(jmat[lgn+Dlgn][col+Dcol]!=2)
  {
   if(jmat[lgn+Dlgn][col+Dcol]>2)
    if(lgn+2*Dlgn<Nlgn && col+2*Dcol<Ncol && col+2*Dcol>=0 && lgn+2*Dlgn>=0)
    {
     if(jmat[lgn+2*Dlgn][col+2*Dcol]<2)
      jmat[lgn+2*Dlgn][col+2*Dcol]=3+(1==jmat2[lgn+2*Dlgn][col+2*Dcol]);
     else return;
    }
    else return;
   jmat[lgn+Dlgn][col+Dcol]=5;
   jmat[lgn][col]=jmat2[lgn][col]*(jmat2[lgn][col]<3);

   for(i=0;i<=2-(lgn+2*Dlgn>=Nlgn || col+2*Dcol>=Ncol || col+2*Dcol<0 || lgn+2*Dlgn<0);i++)
    AffImag(lgn+i*Dlgn,col+i*Dcol,jmat[lgn+i*Dlgn][col+i*Dcol]);
   lgn+=Dlgn;col+=Dcol;
  }
 }
}
int CtrlFin(void)
{
 int i,j;
 for(i=0;i<Nlgn;i++)
  for(j=0;j<Ncol;j++)
   if(jmat[i][j]==3) return FALSE;
 return TRUE;
}

void AffMessage(int n)
{
 char* msg[] = {"(C)2000 Sebastien Tiby","- Congratulations! -"};
 int i;
#ifdef Couleur
 for(i=0;i<=1;i++)
 {
  SetPlane(i);
#endif
  ScrRectFill(&(SCR_RECT){30,30,130,65},&(SCR_RECT){0,0,159,93},A_NORMAL);
  FontSetSys(F_4x6);
  DrawStr(80-DrawStrWidth(msg[n],F_4x6)/2,55,msg[n],A_REVERSE);
#ifdef Couleur
 }
#endif
 FontSetSys(F_8x10);
#ifdef Couleur
 SetPlane(1);
#endif
 DrawStr(50,35,"SOKOBAN",A_REVERSE);
 ngetchx();
}

void jeu(void)
{
 int key;
 do
 {
  if(!Ouvrir()) return;
  do
  {
   key=ngetchx();
   switch(key)
   {
    case kUp	:deplace(-1,0)	;break;
    case kDown	:deplace(1,0)	;break;
    case kLeft	:deplace(0,-1)	;break;
    case kRight	:deplace(0,1)	;break;
    case kF2:
     AffMessage(0);
     Sauve=TRUE;
     Ouvrir();
    break;
   }
  } while(key!=kEsc && !CtrlFin() && key!=kF1 && key!=kF3);
  Sauve=FALSE;
  if(CtrlFin()) AffMessage(1);
 }while(key!=kEsc && key!=kF3);
 Sauve=TRUE;
}

void _main(void)
{
#ifdef Couleur
 if(!GrayMode(GRAY_ON)) return;
#endif
 jeu();
#ifdef Couleur
 GrayMode(GRAY_OFF);
#endif
}