/* SokoEdit (C) 2000 Sebastien Tiby
   Editeur de niveaux pour Sokoban
*/

#define SAVE_SCREEN
#define USE_GRAY_PATCH

#include <nostub.h>
#include <all.h>

 int _ti89;

typedef char MAT[16][26];
#define kEsc	264
#define kClear	263
#define kUp	337
#define kDown	340
#define kLeft	338
#define kRight	344
#define kF1	268
#define kF2	269
#define kF3 	270
#define kF4	271
#define kF5	272
#define kAdd	43
#define kSub	45

 char* Nom= "\0\0        ";
 char cnt=0;

 int Nlgn=1,Ncol=1;
 MAT jmat={};

unsigned char Imag[]=
{
 0x00,0x06,0x00,0x06,0x00,0x00,0x00,0x00,0x00,0x00,
 0x00,0x06,0x00,0x06,0x00,0x54,0x00,0x44,0x00,0x54,
 0x00,0x06,0x00,0x06,0x54,0xA8,0x54,0xA8,0x54,0xA8,
 0x00,0x06,0x00,0x06,0x00,0x78,0xFC,0xFC,0xFC,0x78,
 0x00,0x06,0x00,0x06,0x00,0x78,0x84,0x8C,0xBC,0x78,
 0x00,0x06,0x00,0x06,0x30,0x30,0xFC,0xFC,0x30,0x30,
 0x00,0x06,0x00,0x06,0xFC,0xFC,0xFC,0xFC,0xFC,0xFC,
 0x00,0x06,0x00,0x06,0xFC,0xFC,0xC4,0xC4,0xC4,0xFC,
 0x00,0x06,0x00,0x06,0xFC,0xFC,0xFC,0xFC,0xFC,0xFC,
 0x00,0x06,0x00,0x06,0xFC,0xFC,0x84,0x8C,0xBC,0xFC,
 0x00,0x06,0x00,0x06,0xFC,0xFC,0xCC,0x94,0x9C,0xFC,
 0x00,0x06,0x00,0x06,0xFC,0xFC,0xFC,0xFC,0xFC,0xFC
};
void AffImag(int l,int c,char Img)
{
 int i;
 for(i=0;i<=1;i++)
 {
  SetPlane(i);
  BitmapPut(6*c,6*l,&Imag[10*(Img+6)-60*i],&(SCR_RECT){0,0,159,93},A_REPLACE);
 }
}
int SaisiNom(void)
{
 int i=1,key=0;
 ClrScr();
 DrawStr(1,1,"Level name:",A_REPLACE);
 DrawStr(70,1,&Nom[1],A_REPLACE);
 while(Nom[i]!=0) i++;
 while(key!=13)
 {
  Nom[i]='_'; Nom[i+1]=' '; Nom[i+2]=0;
  DrawStr(70,1,&Nom[1],A_REPLACE);
  key=ngetchx();
  if(((key>='0'&&key<='9'&&i!=1)||(key>='A'&&key<='Z')||(key>='a'&&key<='z'))&&i<9) Nom[i++]=key;
   if(key==257&&(i-1)) i--;
 }
 Nom[cnt=i]=0;
 return (i!=1);
}
int CtrlArchive(void)
{
 SYM_ENTRY* SymPtr = DerefSym(SymFind(Nom+cnt));
 if(!SymPtr) return FALSE;
 if(SymPtr->flags.bits.archived) return TRUE;
 return FALSE;
}

int Ouvrir(void)
{
 SYM_ENTRY* SymPtr = SymFindPtr(Nom+cnt,0);
 unsigned char* VarPtr;
 int i,j;
 if(!SymPtr)
 {
  Ncol=0;Nlgn=0;
  for(i=0;i<16;i++) for(j=0;j<26;j++) jmat[i][j]=0;
  return TRUE;
 }
 else
 {
  VarPtr = (unsigned char*)HeapDeref(SymPtr->handle);
  if(VarPtr[0]*256+VarPtr[1]<6) return FALSE;
  if(VarPtr[3]!=1 && VarPtr[4]!=2) return FALSE;

  Nlgn=VarPtr[5]; Ncol=VarPtr[6];
  for(i=0;i<Nlgn+1;i++)
   memcpy(&jmat[i][0],&VarPtr[7+i*(Ncol+1)],Ncol+1);
  return TRUE;
 }
}

void Sauve(void)
{
 SYM_ENTRY* SymPtr;
 unsigned char* VarPtr;
 int i,j;
 SymPtr = DerefSym (SymAdd (Nom+cnt));
 j=(Ncol+1)*(Nlgn+1)+7;
 VarPtr = (char*)HeapDeref (SymPtr->handle = HeapAlloc(j+2));
 VarPtr[0] = j>>8;
 VarPtr[1] = j&0xff;
 VarPtr[2] = 0;
 VarPtr[3] = 1;
 VarPtr[4] = 2;
 VarPtr[5] = Nlgn;
 VarPtr[6] = Ncol;
 for(i=0;i<Nlgn+1;i++)
  memcpy(&VarPtr[7+i*(Ncol+1)],&jmat[i][0],Ncol+1);
 VarPtr[j] = 0;
 VarPtr[j+1] = STR_TAG;
}

void Rafraichir(void)
{
 int i,j;
 char* menu[] = {"PutSpr","InsRow","DelRow","InsCol","DelCol"};
 FontSetSys(F_4x6);
 for(i=0;i<2;i++)
 {
  SetPlane(i);
  ClrScr();
  for(j=0;j<150;j+=32)
  {
   SCR_RECT Rect = {j,93,j+30,99};
   DrawStr(j+15-DrawStrWidth(menu[j>>5],F_4x6)/2,94,menu[j>>5],A_NORMAL);
   ScrRectFill(&Rect,&(SCR_RECT){0,0,159,99},A_XOR);
  }
 }
 for(i=0;i<=Nlgn;i++) for(j=0;j<=Ncol;j++) AffImag(i,j,jmat[i][j]);
}

void _main(void)
{
 int i,j,sp,key,lgn,col;

 if(SaisiNom())
 {
  if(CtrlArchive())
  {
   DrawStr(1,10,"Variable is archived.",A_REPLACE);
   ngetchx();
  }
  else
  {
   if(!Ouvrir())
   {
    DrawStr(1,10,"Error loading.",A_REPLACE);
    ngetchx();
   }
   else
   {
    GrayMode(GRAY_ON);
    Rafraichir();
    sp=0;lgn=0;col=0;
    do
    {
     AffImag(lgn,col,sp);
//     printf_xy(140,87,"%d/%d",Nlgn,Ncol);
     key=ngetchx();
     AffImag(lgn,col,jmat[lgn][col]);
     lgn += ((key==kDown) && (lgn<Nlgn)) - ((key==kUp) && (lgn>0));
     col += ((key==kRight) && (col<Ncol)) - ((key==kLeft) && (col>0));
     sp += ((key==kAdd) && (sp<5)) - ((key==kSub) && (sp>0));
     switch(key)
     {
      case kF1:
       jmat[lgn][col]=sp;
      break;

      case kF2:
       if(Nlgn<15)
       {
        Nlgn++;
        memmove(&jmat[lgn+1][0],&jmat[lgn][0],26*(15-lgn));
        Rafraichir();
       }
      break;

      case kF3:
       if(Nlgn>0)
       {
        lgn -=(lgn==Nlgn);
        Nlgn--;
        memmove(&jmat[lgn][0],&jmat[lgn+1][0],26*(15-lgn));
        Rafraichir();
       }
      break;

      case kF4:
       if(Ncol<25)
       {
        Ncol++;
        for(i=0;i<16;i++)
         memmove(&jmat[i][col+1],&jmat[i][col],25-col);
        Rafraichir();
       }
      break;

      case kF5:
       if(Ncol>0)
       {
        col-=(col==Ncol);
        Ncol--;
        for(i=0;i<16;i++)
         memmove(&jmat[i][col],&jmat[i][col+1],25-col);
        Rafraichir();
       }
      break;

      case kClear:
       Rafraichir();
       ngetchx();
      break;
     }

    } while(key!=kEsc);
    GrayMode(GRAY_OFF);
   }
  Sauve();
  }
 }
}